/*
 *   Copyright (c) 2005 - 2011 by Thanos Kyritsis
 *
 *   This file is part of ffpocket
 *
 *   FFpocket is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, version 2 of the License.
 *
 *   FFpocket is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with FFpocket; if not, write to the Free Software
 *   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


#ifndef FFPOCKET_FFDECODE_H
#define FFPOCKET_FFDECODE_H 1

#include <stdlib.h>
#include <stdio.h>

#include "libavformat/avformat.h"
#include "libswscale/swscale.h"

#ifndef FALSE
#define FALSE 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#define RESOLUTION 1000


/* Frame Decoding Tools */
int ff_ppm_out(AVFrame *rgb, size_t cols, size_t rows, int pixsize, const char *filename);
int ff_decode_frame(const char *input_filename, const char *timepos, const int onlyoneframe);

/* Audio Decoding Tools */
AVStream *ff_add_audio_stream(AVFormatContext *oc, enum CodecID codec_id, AVCodecContext *ccx);
int ff_decode_audio(const char *outfilename, const char *filename, const char *timepos_start, const char *timepos_stop, const int rangedecoding, const char *cachefilename);
void ff_audio_enc_out(AVFormatContext *ofcx, AVStream *audio_st, const short *samples, int buf_size);

/* User Output */
void ff_display_decoding_progress(long long int timepos, int counter);

/* Utilities */
int isLittleEndian(void);
void fput_le32(FILE *stream, long int val);


#endif

